@echo off
if "%debug%" == "yes" echo on

	:: fddmairq.bat - find valid dma/irq combos
	:: this .bat file calls itself 
	:: when started with the name of a sound file, it calls itself
	:: for every dma/irq combination

	:: if no arguments, display syntax

	if "%1" == "" 		goto syntax

	:: if not 3 arguments, then generate dma/irq combos

	if "%3" == ""		goto gencmdline

	:: program card with dma/irq combo
	:: if not a valid combo, quit
	:: play the sound
	:: if no looping, echo GOOD

	proas d:%1 q:%2 | grep -Q.nz \x07
	if errorlevel 1 	goto quit
	tpcm %3
	if not errorlevel 1 	echo DMA:%1 IRQ:%2 is GOOD!
				goto quit

:gencmdline
	:: verify tsr's are not loaded
	:: we reprogram the card, so they can't be loaded

	pcm -s
	if errorlevel 1		goto uhohpcm
	pcmfun -s
	if errorlevel 1		goto uhohpcmfun

	:: foreach dma
	:: foreach irq
	:: run the .bat file with dma/irq combo and the sound file name

	fe dma ( [0-6] ) do fe irq ( [01-15] ) do call %0 $dma $irq %1 
				goto quit

:syntax
	echo Syntax: fddmairq sound.wav
	echo Use this program to locate valid DMA/IRQ channels
	echo Requires that "pcm.com" and "pcmfun.com" NOT be loaded.
	echo Requires "proas.exe", "tpcm.exe" and "pcm.com" in the PATH.
	goto quit

:uhohpcm
	echo Sorry, "pcm.com" must NOT be loaded, as we are changing IRQ/DMA on the fly.
	goto quit

:uhohpcmfun
	echo Sorry, "pcmfun.com" must NOT be loaded, as we are changing IRQ/DMA on the fly.
	goto quit

:quit
	cat nul



